' analog clock
' converted from Pascal to Lua to AllegroBASIC
' by Cybermonkey 2/2016

KEY_ESC          = 59
screen (960,544,"Analog Clock")
setfps (30) ' That's enough ...
PI = 3.141
xcenter = screenwidth/2
ycenter = screenheight/2
paper (0,90,82)
textsize (2)

do
cls
ink (0,0,0)
fillcircle (xcenter, ycenter, 150)
ink (50,255,50)

for i=1 to 11
  if (i<>3) and (i<>6) and (i<>9) then
    fillcircle (round(cos((i * 30) * PI / 180 - PI / 2) * 140 + xcenter), round(sin((i * 30) * PI / 180 - PI / 2) * 140 + ycenter), 3)
 endif
next

drawtext (xcenter - 145, ycenter - 5,"9")
drawtext (xcenter + 135, ycenter - 5,"3")
drawtext (xcenter - 15, ycenter - 145,"12")
drawtext (xcenter - 5, ycenter + 130,"6")

ink (0,255,0)

second = val (right (time,2))
hour = val (left (time,2))
minute = val (mid (time,3,2))

xsecond = round(cos(second * PI / 30 - PI / 2) * 120 + xcenter)
ysecond = round(sin(second * PI / 30 - PI / 2) * 120 + ycenter)
xminute = round(cos(minute * PI / 30 - PI / 2) * 100 + xcenter)
yminute = round(sin(minute * PI / 30 - PI / 2) * 100 + ycenter)
xhour = round(cos((hour * 30 + minute / 2) * PI / 180 - PI / 2) * 80 + xcenter)
yhour = round(sin((hour * 30 + minute / 2) * PI / 180 - PI / 2) * 80 + ycenter)

ink (255,0,0)
line (xcenter, ycenter, xsecond, ysecond)
ink (255,255,255)
line (xcenter, ycenter - 1, xminute, yminute)
line (xcenter - 1, ycenter, xminute, yminute)

line (xcenter, ycenter - 1, xhour, yhour)
line (xcenter - 1, ycenter, xhour, yhour)
ink (0,255,0)
fillcircle (175,175,5)
ink(255,255,255):textsize (1)
drawtext (xcenter - 30, ycenter + 160,TIME)
textsize (2)

sync
until (keystate (KEY_ESC) = true) or (windowclosed=true)
