' Mandelbrot ported from CMLua
' by Cybermonkey

screen (640,480,"Mandelbrot")
miter=128
zm=120
textsize (2)
paper (255,255,255)
cls
time1=tickcount
for y=0 to 479 
  for x=0 to 639 
    zx=0
    zy=0
    cx= (x-320)/zm
    cy= (y-240)/zm
    i = miter
  while (zx*zx+zy*zy <4) and (i >0)
    tmp = zx * zx - zy * zy + cx
    zy = 2 * zx * zy + cy
    zx = tmp
    i=i-1
  wend
  ink (i*12,i*8,i*4)
   pset (x,y)
   if windowclosed=true then end
  next
  redraw
next


time2=tickcount
ink (0,0,0)
timex=(time2-time1)/1000
drawtext (0,0,"Time: "+str (timex)+" seconds.")
sync
inkey
end
