' tetraeder.bas
' converted from Yabsic to AllegroBASIC
' by Cybermonkey 6/2019

data  -1,-1,1,  1,-1,-1,  1,1,1, -1,1,-1
data   1,2,4,  2,3,4,  1,3,4,  1,2,3



KEY_ESC          = 59

screen (1024,700,"Tetraeder")
setfps (60)


paper (255,255,255)

sw=fix(screenwidth/2)
sh=fix(screenheight/2)

dim opoints(5,4)

for n=1 to 4
 for p=1 to 3
   read a
     opoints(n,p)=a
   next
 next


dim triangles(5,4)

for n=1 to 4
  for p=1 to 3
   read a
   triangles(n,p)=a
  next
next

phi=0:dphi=0.1:psi=0:dpsi=0.05

dim points(5,4)


r=60:g=20
dr=0.5:dg=1.2:db=3



do
cls


  phi=phi+dphi
  psi=psi+dpsi
  for n=1 to 4
    points(n,1)=opoints(n,1)*cos(phi)-opoints(n,2)*sin(phi)
    points(n,2)=opoints(n,2)*cos(phi)+opoints(n,1)*sin(phi)
    p2=          points(n,2)*cos(psi)-opoints(n,3)*sin(psi)
    points(n,3)=opoints(n,3)*cos(psi)+ points(n,2)*sin(psi)
    points(n,2)=p2
  next


  r=r+dr
   if (r<0 or r>60) then
      dr=-1*dr
   endif

  g=g+dg
  if (g<0 or g>60) then
    dg=(-1)*dg
  endif
  b=b+db
  if (b<0 or b>60) then
     db=(-1)*db
  endif

  dm=dm+0.01

  m=120-80*sin(dm)


  for n=1 to 4
    p1=fix(triangles(n,1))
    p2=fix(triangles(n,2))
    p3=fix(triangles(n,3))

     x1=points (p1,1)
     y1=points (p2,1)
     z1=points (p3,1)

     x2=points (p1,2)
     y2=points (p2,2)
     z2=points (p3,2)

     x3=points (p1,3)
     y3=points (p2,3)
     z3=points (p3,3)

    n1= x1+y1+z1
    n2= x2+y2+z2
    n3= x3+y3+z3



    if (n3>0) then
      sp=n1*0.5-n2*0.7-n3*0.6
      ink (60+r+30*sp,60+g+30*sp,60+b+30*sp)
      filltriangle (sw+m*x1,sh+m*x2,sw+m*y1,sh+m*y2,sw+m*z1,sh+m*z2)
    endif
  next

sync
until (keystate (KEY_ESC) = true) or (windowclosed=true)

